
package graphhandler;

/**Class that represents a Node in the Union Find objects */
public class UNode{
        int id, father;
        int rank;

        /**Constructor that makes a new UNode with an id equal of the parameter*/
        public UNode(int id){ this(id, ((Integer)0).intValue() );}
        public UNode(int id, int rank){this(id, rank, id); }
        public UNode(int id, int rank, int father){setID(id); setRank(rank);setFather(father);}
        public int getId(){ return this.id; }
        public void setID(int id){ this.id=id;}
        public int getRank(){return this.rank;}
        public void setRank(int rank){ if(rank>0) this.rank=rank;}
        public void setFather(int father){this.father=father;}
        public int getFather(){return this.father;}
        public boolean hasFather(){return father!=id;}
        /**Compares the two UNodes based on their rank. */
        public int compareTo(Object o) {
            if( ((UNode) o).getRank() == this.rank   )
                    return 0;
            else if( ((UNode) o).getRank() < this.rank   )
                    return -1;
            return 1;
        }
        
        /** Compares the UNode's id with u's and returns true if they are equal */
        @Override public boolean equals(Object u) {
           if (u == null)  // Null references are not equal to this instance.
               return false;
           if (!u.getClass ().equals (UNode.class)) //Neither are they instances of different classes
            return false;
           return (((UNode) u).id == this.id);
        }

        /** Generates the hashcode of the object.*/
        @Override public int hashCode() {
            return (41 * (41 + (Integer)getId()) + (Integer)getFather());
        }

        /** Returns the vertex's id as a string. */
        @Override public String toString(){
                return "" + this.id;
        }
}